----------------------------------------------------------------------------------
-- Engineer: Bridget Benson
-- Create Date: 09/21/2015 09:02:18 AM
-- Description: Template file for test benches
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

--make the entity name of your simulation file the same name as the file you  wish to simulate
--with the word Sim at the end of it.  The entity is empty because a simulation file does not 
--connect to anything on the board.
entity SimTemplate is
--  Port ( );
end SimTemplate;

architecture Behavioral of SimTemplate is

    -- Component Declaration for the Unit Under Test (UUT) (the module you are testing)
    COMPONENT SerialControl
        Port ( RXD : in STD_LOGIC;
               RXD_DEBUG : out STD_LOGIC;
               TXD : out STD_LOGIC;
               TXD_DEBUG : out STD_LOGIC;
               CLK : in STD_LOGIC;
               btnC : in STD_LOGIC;
               sw : in STD_LOGIC_VECTOR (15 downto 0);
               led : out STD_LOGIC_VECTOR (15 downto 0);
               module_start_debug : out STD_LOGIC;
               state_debug : out STD_LOGIC_VECTOR(3 downto 0);
               tx_done_debug : out STD_LOGIC);
    END COMPONENT;

    --Signal declarions - can be the same names as the ports
    signal RXD : std_logic := '0';
    signal RXD_DEBUG : std_logic;
    signal TXD : std_logic;
    signal TXD_DEBUG : std_logic;
    signal sw : std_logic := '0';
    signal sw_na : std_logic_vector(14 downto 0) := "000000000000000";
    signal btnC : std_logic := '0';
    signal led : std_logic_vector(15 downto 0);
    signal module_start : std_logic;
    signal state_debug : std_logic_vector(3 downto 0);
    signal tx_done_debug : std_logic;
	--For designs with a CLK, uncomment the following
	signal CLK : std_logic := '0';
	
	--For designs with a CLK uncomment the following
	constant CLK_period: time := 10 ns;
	
    begin
    
		-- Map the UUT's ports to the signals
        uut: SerialControl PORT MAP (
            CLK => CLK,
            RXD => RXD,
            RXD_DEBUG => RXD_DEBUG,
            TXD => TXD,
            TXD_DEBUG => TXD_DEBUG,
            btnC => btnC,
            sw(15) => sw,
            sw(14 downto 0) => sw_na,
            led => led,
            module_start_debug => module_start,
            state_debug => state_debug,
            tx_done_debug => tx_done_debug
        );

		--For designs with a CLK uncomment the following
		CLK_process : process
		begin
			CLK <= '0';
			wait for CLK_period/2;
			CLK <= '1'; 
			wait for CLK_period/2;
		end process;
		
		
        stim_proc: process
        begin
            -- now assign values to the input signals
			-- you should include at least 8 test cases for all labs that 
			-- are representative of different inputs for your circuit
			-- if you can do an exhaustive test (like those that have only 8
			-- or 16 possible input combinations) - do an exhaustive test
            sw <= '0';
            wait for 100 ns;
            sw <= '1';
            wait for 35 ms;
            sw <= '0';
            wait for 15 ms;
            sw <= '1';
            wait;
        end process;
end Behavioral;
