----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12/01/2017 01:23:24 AM
-- Design Name: 
-- Module Name: printBuffer - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;                        
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity printBuffer is
    Port (
        INPUT : in STD_LOGIC_VECTOR(127 downto 0);
        SEND_SIG : in STD_LOGIC;
        TX_DONE : in STD_LOGIC;
        TX_EN : out STD_LOGIC := '0';
        EMPTY : inout STD_LOGIC := '1';
        TO_PRINT : out STD_LOGIC_VECTOR(7 downto 0));
end printBuffer;

architecture Behavioral of printBuffer is

--constant zeros : std_logic_vector(127 downto 0) := x"00000000000000000000000000000000";
signal INPUT_SHIFT : std_logic_vector(127 downto 0) := x"00000000000000000000000000000000";
signal SEL : integer := 0;
signal SEL_MAX : integer := 15;
signal EMPTY_SEL : std_logic;

begin

input_buffer : process(SEND_SIG)
begin
    if(rising_edge(SEND_SIG) ) then
        --INPUT_SHIFT <= zeros;
        INPUT_SHIFT <= INPUT;
    end if;
end process;

with SEL select
TO_PRINT <= INPUT_SHIFT(127 downto 120)  when 0,
        INPUT_SHIFT(119 downto 112) when 1,
        INPUT_SHIFT(111 downto 104) when 2,
        INPUT_SHIFT(103 downto 96) when 3,
        INPUT_SHIFT(95 downto 88) when 4,
        INPUT_SHIFT(87 downto 80) when 5,
        INPUT_SHIFT(79 downto 72) when 6,
        INPUT_SHIFT(71 downto 64) when 7,
        INPUT_SHIFT(63 downto 56) when 8,
        INPUT_SHIFT(55 downto 48) when 9,
        INPUT_SHIFT(47 downto 40) when 10,
        INPUT_SHIFT(39 downto 32) when 11,
        INPUT_SHIFT(31 downto 24) when 12,
        INPUT_SHIFT(23 downto 16) when 13,
        INPUT_SHIFT(15 downto 8) when 14,
        INPUT_SHIFT(7 downto 0) when 15,
        "00000000" when others;

with EMPTY select
EMPTY_SEL <= SEND_SIG when '1',
             TX_DONE when '0',
             '0' when others;


tx : process(TX_DONE)
begin
    if( rising_edge(TX_DONE)) then
        if(SEL < SEL_MAX) then
            SEL <= SEL + 1;
        else
            SEL <= 0;
        end if;
    end if;
end process;

empty_proc : process(EMPTY_SEL)
begin
    if(rising_edge(EMPTY_SEL)) then
        if(EMPTY = '1') then
            EMPTY <= '0';
        elsif(SEL = SEL_MAX) then
            EMPTY <= '1';
        end if;
    end if;
end process;
            
TX_EN <= NOT EMPTY;

end Behavioral;
